#pragma once

#include <d3d9.h>
#include "d3dx9.h"
#include <string>

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

class DXRender {
private:
	struct D3DTLVERTEX {
		float x, y, z, rhw;
		uint64_t color;
	};
public:
	DXRender() { }
	DXRender(IDirect3DDevice9* Device);
	~DXRender();

	void BeginRender();
	void EndRender();

	int GetFPS();
	void DrawLine(int x0, int y0, int x1, int y1, unsigned long color);
	void DrawRectangle(int x, int y, int w, int h, unsigned long color);
	void DrawFilledRectangle(int x, int y, int w, int h, unsigned long color);
	void DrawOutlinedRectangle(int x, int y, int w, int h, unsigned long color);
	void DrawTextX(std::string text, int x, int y, unsigned long color, bool center = true, bool outline = true, int font = 0);

	RECT GetTextDimensions(std::string text);

	IDirect3DTexture9* map;
	void LoadTexture(const std::string& filePath);
	void RenderMap();
	void GetViewport();
	void Calculate();

	float w;
	float h;
	float mapSize;

	float left;
	float top;
	float bottom;
	float right;

private:
	int sFPS = 0;
	IDirect3DDevice9* xDevice = nullptr;
	ID3DXFont* Font = nullptr;
	ID3DXFont* Font_2 = nullptr;
	ID3DXLine* Line = nullptr;
};