#pragma once

#include <d3d9.h>
#include "d3dx9.h"
#include "Render.h"

std::string GetString(const int len);
std::wstring Convert(const std::string& as);

class DXOverlay {
private:
	struct WindowRectangle : public RECT {
		int W() { return right - left; }
		int H() { return bottom - top; }
	};
public:
	//DXOverlay() { };
	~DXOverlay();
	DXOverlay();

	DXRender CreateRender();
	HWND GetOverlay();
	bool IsInit();

private:
	void CreateOverlay();
	void InitDX9();

	HWND OverlayWindow;
	int sFPS = 0;
	bool sInit = false;

	IDirect3D9* D3D = nullptr;
	IDirect3DDevice9* vDevice = nullptr;

	static LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
};